﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GraphicsBoxCCharpSample
{
    public partial class Form1 : Form
    {
        private int YOffset = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void graphicsBox1_Resize(object sender, EventArgs e)
        {
            //テストパターンの描画
            DrawTestPattern();
        }

        private void graphicsBox1_MouseWheeled(object sender, MouseEventArgs e)
        {
            // 表示位置の調整
            YOffset -= e.Delta;
            //テストパターンの描画
            DrawTestPattern();
        }

        private void DrawTestPattern()
        {

            // GraphicsBoxのGraphicsプロパティより取得
            Graphics g = graphicsBox1.Graphics;
            // GraphicsBoxのFontsプロパティで設定したフォント
            Font f = graphicsBox1.Fonts;

            Pen p1 = System.Drawing.Pens.Red;
            Pen p2 = System.Drawing.Pens.Green;

            int LineStep = 16;

            int i;
            int j;

            //クリア
            g.Clear(graphicsBox1.BackColor);

            for (i = (YOffset % LineStep) - LineStep; i < graphicsBox1.Height; i += LineStep)
            {

                // 線の描画
                g.DrawLine(
                    p1,
                    0,
                    i,
                    graphicsBox1.Width,
                    i);
                for (j = i + 1; j < i + LineStep; j += 2)
                {
                    g.DrawLine(
                        p2,
                        0,
                        j,
                        graphicsBox1.Width,
                        j);
                }

                //文字の描画
                g.DrawString(
                    (i - YOffset).ToString(),
                    f,
                    System.Drawing.Brushes.Blue,
                    20,
                    i);

            }

            //描画更新
            graphicsBox1.Refresh();
        }


    }
}
